<?php
/*
 * Created For BZ9.com
 * Author: Dave
 * Copyright: BZ9.com
 * Licence: Commercial, See included licence file.
 */
if(!defined("APPLICATION_PATH")){ die("No DIRECT Access"); }
class error
{
    Private $Reg;
    private $warnings = array();
    private $form_errors = array();
    private $general_errors = array();
    private $fatal = array();

    public function __construct($Registry)
    {
        $this->Reg = $Registry;
        $this->Reg->log->log("class_load","Error Class");
    }

    public function raise_error($errtype,$error,$access)
    {
        $this->Reg->log->log("Error :".$errtype,$error);
        if($errtype == "fatal"){
           array_push($this->fatal, $error);
            $this->Reg->tpl->set_section("public");
            $this->Reg->tpl->showview("error");
        }
        if($errtype == "warning"){
            array_push($this->warnings, $error);
            return;
        }
        if($errtype == "form"){
            array_push($this->form_errors, $error);
            return;
        }
        if($errtype == "general"){
            array_push($this->general_errors, $error);
            return;
        }
    }

    public function get_all($data)
    {
        if($fatal = $this->get_fatal())
        {
            $data['fatal'] = $fatal;
        }
        if($page_warnings = $this->get_warnings())
        {
            $data['warnings'] = $page_warnings;
        }
        if($form_errors = $this->get_form())
        {
            $data['form_errors'] = $form_errors;
        }

        if($general_errors = $this->get_general())
        {
            $data['general_errors'] = $general_errors;
        }

        return $data;
    }

    public function get_fatal()
    {
        if(count($this->fatal) > 0){
            $fatal_html = "";
            foreach($this->fatal as $key => $value)
            {
                $fatal_html .= "<div class='fatal_box'><div class='fatal_item'>$value</div></div>";
            }
            return $fatal_html;
        }
        return false;
    }

    public function get_warnings()
    {
        if(count($this->warnings) > 0){
            $warning_html = "";
            foreach($this->warnings as $key => $value)
            {
                $warning_html .= "<div class='warning_box'><div class='warning_item'>$value</div></div>";
            }
            return $warning_html;
        }
        return false;
    }

    public function get_form()
    {

        if(count($this->form_errors) > 0){
            $form_html = "";
            foreach($this->form_errors as $key => $value)
            {
                $form_html .= "<div class='form_error_box'><div class='form_error_item'>$value</div></div>";
            }
            return $form_html;
        }
        return false;
    }

    public function get_general()
    {

        if(count($this->general_errors) > 0){
            $general_html = "";
            foreach($this->general_errors as $key => $value)
            {
                $general_html .= "<div class='general_error_box'><div class='general_error_item'>$value</div></div>";
            }
            return $general_html;
        }
        return false;
    }

    public function is_errors($type)
    {
        $amount = 0;
        if($type == "form")
        {
            $amount = count($this->form_errors);
        }

        if($type == "warning")
        {
            $amount = count($this->warnings);
        }

        if($type == "general")
        {
            $amount = count($this->general_errors);
        }

        if($amount > 0){
            return $amount;
        } else {
            return false;
        }
    }
}
